// Grep - Search a string in specified files
// Usage: java Grep <string> [-all] <files> ...
//	  -all returns 0 if string is present in all files
//	  returns 0 when match has been found
//	  returns 1 when match hasn't been found
//	  returns 2 in case of file error
//	  returns 3 in case of bad arguments
//	  the returned number corresponds to the last comparison result
// (c)1998 Romain GUY

import java.io.*;

public class Grep
{
  static final int MatchFound = 0;
  static final int MatchNotFound = 1;
  static final int FileError = 2;
  static final int UseError = 3;
  static boolean Result = true;
  static boolean AllFlag = false;
  static boolean AllFound = true;
  static int AllCount = 0;
  static String s;

  public static void errorManager(int Errc)
  {
    System.exit(Errc);
  }

  public static void main(String args[])
  {
    File fArray[] = new File[args.length];
    String sArray[] = new String[args.length];
    if ((args.length < 2) || (args[0].equals("-all")))
    {
      System.out.println("\nUsage: java Grep <string> [-all] <file1> ... <fileN>");
      errorManager(UseError);
    }
    for (int i = 1; i < args.length; i++)
    {
      if (args[i].equals("-all"))
        AllFlag = true;
    }
    for (int i = 1; i < args.length; i++)
    {
      if (!args[i].equals("-all"))
      {
        fArray[i] = new File(args[i]);
        if (!fArray[i].exists())
        {
          System.out.println("\n" + args[i] + " does not exist !");
          errorManager(FileError);
        }
        try
        {
          RandomAccessFile raf = new RandomAccessFile(fArray[i], "r");
          byte b[] = new byte[new Long(raf.length()).intValue()];
          raf.read(b);
          raf.close();
          s = new String(b);
          int p = s.indexOf(args[0]);
          if (p != -1)
            Result = true;
          else
            Result = false;
          if (!Result)
          {
            if (AllFlag)
            {
              AllFound = false;
              sArray[AllCount] = args[i];
              AllCount++;
            } else
              System.out.println(args[0] + " has not been found in " + args[i]);
          } else
          {
            if (!AllFlag)
              System.out.println(args[0] + " has been found in " + args[i]);
          }
        }
        catch (IOException e)
        {
          System.out.println("\nError opening file " + args[i]);
          errorManager(FileError);
        }
      }
    }
    if (AllFlag)
    {
      if (!AllFound)
      {
        System.out.print(args[0] + " is not present in files: ");
        for (int i = 0; i < sArray.length; i++)
        {
          if (sArray[i] != null)
            System.out.print(sArray[i] + " ");
        }
        System.out.println("");
        errorManager(MatchNotFound);
      } else
        System.out.println(args[0] + " has been found in each file");
    }
    if (Result)
      errorManager(MatchFound);
    else
      errorManager(MatchNotFound);
  }
}

// I'm gonna Grep Ya !!
