// A file is Up To Date if it's older than all the other dependances
// Ex: java UpToDate Source.java Source.class
//     if Source isn't Up To Date, Source.class is older, you have to recompile it

// Error codes (for errorlevel in batch files):
//	0	Up To Date
//	1	Not Up To Date
//	2	A file is missing
//	3	Bad arguments

// (c)1998 Romain GUY

import java.io.*;

public class UpToDate
{
  static final int UpToDate = 0;
  static final int NotUpToDate = 1;
  static final int NotFound = 2;
  static final int UseError = 3;
  static long RefDate;
  static long DepDate;
  static boolean IsUpToDate = true;

  public static void errorManager(int Errc)
  {
    System.exit(Errc);
  }

  public static void main(String args[])
  {
    File fArray[] = new File[args.length];
    if (args.length < 2)
    {
      System.out.println("\nUsage: java UpToDate <file> [dependance1 | dependance2 | ...]");
      errorManager(UseError);
    }

    for(int i = 0; i < args.length; i++)
      fArray[i] = new File(args[i]);
    for(int i = 0; i < args.length; i++)
    {
      if (!fArray[i].exists())
      {
        System.out.println("\n" + args[i] + " does not exist !");
        errorManager(NotFound);
      }
    }
    RefDate = fArray[0].lastModified();
    for(int i = 1; i < args.length; i++)
    {
      DepDate = fArray[i].lastModified();
      if (DepDate >= RefDate)
        IsUpToDate = true;
      else
        IsUpToDate = false;
    }
    if (IsUpToDate)
    {
      System.out.println(args[0] + " is up to date");
      errorManager(UpToDate);
    }
    else
    {
      System.out.println(args[0] + " is not up to date");
      errorManager(NotUpToDate);
    }
  }
}

// Are You Up To Date ? Now, I Am ;)
